<?PHP

if ($homepage == "") {
	echo "Fehler: Aktion abgebrochen!";
    exit;
}

function filterzahlen($variablezahlen) {
	$variablezahlen = preg_replace("/[^0-9]/", "", $variablezahlen);
	return $variablezahlen;
}

function filterupload($variableupload) {
	$variableupload = str_replace(" ", "_", $variableupload);
	$variableupload = strtolower($variableupload);
	$variableupload = preg_replace("/[^a-z0-9-_.]/", "", $variableupload);
	return $variableupload;
}

$MediaDirectory = $server_path.'/content/media/' ;

$AllowedTypes = array('file','image','flash') ;

$AllowedExtensions['file'] = array('avi','mov','wmv','mpg','mpeg','mp3','pdf','doc','ppt','xls','txt','zip') ;
$AllowedExtensions['image'] = array('jpg','gif','jpeg','png') ;
$AllowedExtensions['flash'] = array('swf','flv') ;

$AvailableIcons = array('avi','doc','flv','gif','jpg','jpeg','mpg','mpeg','mp3','mov','pdf','png','ppt','swf','txt','xls','zip') ;

if($_GET['type'] == "")
{
	if(isset($_GET['types']) && in_array($_GET['types'], $AllowedTypes))
	{
		$type = $_GET['types'];
	}
	else
	{
		$type = 'file';
	}
	$urltype = 'types='.$type;
}
else
{
	if(in_array($_GET['type'], $AllowedTypes) && $_GET['type'] != 'file')
	{
		$type = $_GET['type'];
		$urltype = 'type='.$type;
	}
}

if($type == "")
{
	echo 'Fehler: Falscher Typ!';
	exit;
}

if(!file_exists($MediaDirectory.$type.actualfolder())) 
{
	echo 'Fehler: Falscher Pfad!';
	exit;
}

if(isset($_GET['delete']) && file_exists(fileactionpath().$_GET['delete'])) 
{
	delete($_GET['delete']);
}

if(isset($_POST['foldername']))
{
	makefolder(cleanpathfromget($_POST['foldername']));
}

if(isset($_FILES['uploadfile']))
{
	if(isset($_POST['imgwidth']))
	{
		$img_width = filterzahlen($_POST['imgwidth']);
	}
	else
	{
		$img_width = '0';
	}
	uploadfile($_FILES['uploadfile'], $img_width);
}

function cleanpathfromget($path)
{
	global $server_path, $homepage;
	
	$path = utf8_decode($path);
	$path = rawurldecode($path);
	$path = strip_tags($path);
	$path = stripslashes($path);
	$path = str_replace( $server_path, "", $path );
	$path = str_replace( $homepage, "", $path );
	$path = str_replace( "../", "", $path );
	
	return $path;
}
	
function makeurlfolder($urlfolder)
{
	$urlfolder = rawurlencode(utf8_encode($urlfolder));
	return $urlfolder;
}

function actualfolder()
{
	if(isset($_GET['actualfolder']))
	{
		$actualfolder = cleanpathfromget($_GET['actualfolder']);
		if(! ereg('/$', $actualfolder) )
		{
			$actualfolder .= '/';
		}
		if(strpos($actualfolder, '/') !== 0 )
		{
			$actualfolder = '/'.$actualfolder;
		}
		return $actualfolder;
	}
	else
	{
		return '/';
	}
}

function lastfolder()
{
	$folderpath = actualfolder();
	$killlastslash = substr($folderpath, 0, -1);
	$lastfolder = substr($killlastslash, 0, strrpos($killlastslash, '/'));
	return $lastfolder.'/';
}

function seticon($datei)
{
	global $AvailableIcons;
	
	$icon = explode('.', $datei);
	if(in_array(strtolower($icon[1]), $AvailableIcons))
	{
		return strtolower($icon[1]);
	}
	else
	{
		return 'default';
	}
}

function fileactionpath()
{
	global $MediaDirectory, $type;
	
	$fileactionpath = $MediaDirectory.$type.cleanpathfromget(actualfolder());

	return $fileactionpath;
	
}

function fileexists($file)
{
	$file = cleanpathfromget($file);
	$file = str_replace( "/", "", $file );

	if(file_exists(fileactionpath().$file)) 
	{
		return $file;
	}
	else
	{
		sendalert(rawurlencode('Fehler: Datei/Ordner existiert nicht'));
		return false;
	}
	
}

function delete($file)
{
	global $demoversion;
	
	if(!$demoversion)
	{
		if(fileexists($file))
		{
			$datei = fileactionpath().$file;
				
			if (is_dir($datei."/"))
			{
				$verzeichnis = opendir ($datei);
				while(false !== ($inhalt = readdir ($verzeichnis)))
				{
					if ( $inhalt != "" && $inhalt != "." && $inhalt != ".." )
					{
						sendalert(rawurlencode('Fehler: Das Verzeichnis enthlt noch Dateien. Nur leere Verzeichnisse knnen gelscht werden!'));
						return false;
					}
				}
				closedir($verzeichnis);
				if(!rmdir($datei."/"))
				{
					sendalert(rawurlencode('Fehler: Das Verzeichnis '.$file.' konnte nicht gelscht werden!'));
				}
				/*
				else
				{
					sendalert(rawurlencode('Das Verzeichnis '.$file.' wurde gelscht!'));
				}
				*/
			}
			else
			{
				if(!unlink($datei))
				{
					sendalert(rawurlencode('Fehler: Die Datei '.$file.' konnte nicht gelscht werden!'));
				}
				/*
				else
				{
					sendalert(rawurlencode('Die Datei '.$file.' wurde gelscht!'));
				}
				*/
			}
		}
	}
	else
	{
		sendalert(rawurlencode('Fehler: Diese Funktion wird in der Demoversion nicht untersttzt!'));
	}
}

function makefolder($name)
{
	global $demoversion;
	
	if(!$demoversion)
	{
		$name = strip_tags($name);
		$name = stripslashes($name);
		$name = str_replace( ".", " ", $name );
		$name = preg_replace( "~( +)~", " ", $name );
		$name = trim($name);
		$name = filterupload($name);
		
		if($name != "") 
		{
			$newfolder = fileactionpath().$name;
			if(!file_exists($newfolder)) 
			{
				if(mkdir($newfolder, 0775))
				{
					sendalert(rawurlencode('Das Verzeichnis mit dem Namen '.$name.' wurde angelegt!'));
				}
				else
				{
					sendalert(rawurlencode('Fehler: Das Verzeichnis mit dem Namen '.$name.' konnte nicht angelegt werden!'));
				}
			}
			else
			{ 
				sendalert(rawurlencode('Ein Verzeichnis mit dem Namen '.$name.' existiert bereits!'));
			}
		}  
		else
		{
			sendalert(rawurlencode('Bitte vergeben Sie erst einen Namen fr das Verzeichnis!'));
		}
	}
	else
	{
		sendalert(rawurlencode('Fehler: Diese Funktion wird in der Demoversion nicht untersttzt!'));
	}
}

function resizeimage($imagefile, $measure)
{
	$format = GetImageSize($imagefile);
	list($width_orig, $height_orig) = $format;
	
	if($width_orig >= $measure || $height_orig >= $measure)
	{
		if($width_orig >= $height_orig)
		{
			$width = $measure;
			$height = (int) (($measure / $width_orig) * $height_orig);
		}
		else
		{
			$width = (int) (($measure / $height_orig) * $width_orig);
			$height = $measure;
		}
		
		if ($format[2] == 1)
		{
			$image_p = imagecreate($width, $height);
			$black = imagecolorallocate($image_p, 0x00, 0x00, 0x00);
			$trans = imagecolortransparent($image_p, $black);
			imagefill($image_p, 0, 0, $trans);
			$image = imagecreatefromgif($imagefile);
			imagecopyresized($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
			imagegif($image_p, $imagefile);
		}
		elseif ($format[2] == 2)
		{
			$image_p = imagecreatetruecolor($width, $height);
			$image = imagecreatefromjpeg($imagefile);
			imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
			imagejpeg($image_p, $imagefile, 80);
		}
		elseif ($format[2] == 3)
		{
			$image_p = imagecreatetruecolor($width, $height);
			imagealphablending($image_p, false);
			imagesavealpha($image_p, true);
			$image = imagecreatefrompng($imagefile);
			imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
			imagepng($image_p, $imagefile);
		}
	}
}

function resourcetype($type)
{
	if($type == 'file') {
		$resource = 'Dateiverwaltung';
	}
	if($type == 'image') {
		$resource = 'Bildverwaltung';
	}
	if($type == 'flash') {
		$resource = 'Flashverwaltung';
	}
	return $resource;
}

function uploadfile($file, $size)
{
	global $demoversion, $type, $AllowedExtensions;
	
	if(!$demoversion)
	{
		if($file['name'] != "")
		{
			$filename = $file['name'];
			$filename = preg_replace('/\\.(?![^.]*$)/', '_', $filename);
			
			$extension = substr($filename, strrpos($filename, '.') + 1);
			$extension = strtolower($extension);
			
			$nameneu = filterupload($filename);
			$dateipath = fileactionpath().$nameneu;
			
			if(!file_exists($dateipath))
			{
				if(in_array($extension, $AllowedExtensions[$type]))
				{
					if (move_uploaded_file($file['tmp_name'], $dateipath)) 
					{
						if($type == 'image' && $size != '' && $size != '0')
						{
							resizeimage($dateipath, $size);
						}
						
						$oldumask = umask(0) ;
						chmod( $dateipath, 0664 ) ;
						umask( $oldumask ) ;
					
						sendalert(rawurlencode('Die Datei '.$nameneu.' wurde erfolgreich bertragen!'));
					}
					else
					{
						sendalert(rawurlencode('Fehler: Die Datei '.$nameneu.' konnte nicht bertragen werden!'));
					}
				}
				else
				{
					sendalert(rawurlencode('Fehler: Das Format '.$extension.' ist in der '.resourcetype($type).' nicht erlaubt!'));
				}
			}
			else
			{
				sendalert(rawurlencode('Fehler: Eine Datei mit dem Namen '.$nameneu.' existiert bereits. Die Datei wurde nicht bertragen!'));
			}
		}
		else
		{
			sendalert(rawurlencode('Fehler: Bitte whlen Sie erst eine Datei von Ihrem Computer!'));
		}
	}
	else
	{
		sendalert(rawurlencode('Fehler: Diese Funktion wird in der Demoversion nicht untersttzt!'));
	}
}

?>
